#property copyright " 2007 BJF Trading Group"
#property link      "http://iticsoftware.com"

#define major   1
#define minor   3

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 OrangeRed
#property indicator_color2 PaleGreen
#property indicator_color3 OrangeRed
#property indicator_color4 PaleGreen
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

extern int Width.Min = 1;
extern int Width.Max = 25;
extern int Height.Min = 15;
extern int Height.Max = 1000;

extern int RVI.Period = 12;
extern int Bands.Period = 65;
extern double Bands.Deviation = 1.3;

extern int MaxBars = 1000;

extern int Shift.Arrow = 40;
extern int Shift.Dot = 20;
extern int Shift.Line = 0;

double UpperFr[];
double LowerFr[];
double UpperFr2[];
double LowerFr2[];

double RVIBuffer[];
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string prefix = "PowerRVI-Div";

void init() 
{
  IndicatorBuffers(8);
    
  SetIndexBuffer(0, UpperFr);
  SetIndexBuffer(1, LowerFr);
  SetIndexBuffer(2, UpperFr2);
  SetIndexBuffer(3, LowerFr2);
  
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexStyle(1, DRAW_ARROW);
  SetIndexStyle(2, DRAW_ARROW);
  SetIndexStyle(3, DRAW_ARROW);
    
  SetIndexArrow(0, 234);
  SetIndexArrow(1, 233);
  SetIndexArrow(2, 159);
  SetIndexArrow(3, 159);

  SetIndexBuffer(4, RVIBuffer);
  SetIndexBuffer(5, MovingBuffer);
  SetIndexBuffer(6, UpperBuffer);
  SetIndexBuffer(7, LowerBuffer);
  
  SetIndexDrawBegin(4, RVI.Period);
  SetIndexDrawBegin(5, Bands.Period);
  SetIndexDrawBegin(6, Bands.Period);
  SetIndexDrawBegin(7, Bands.Period);   
  
  clear();
}

void deinit()
{
  clear();
}

void start2()
  {

  //-----
  
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars <= Bands.Period) return;
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=Bands.Period;i++)
        {
         RVIBuffer[Bars-i]=EMPTY_VALUE;
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   
   for(i=0; i<limit; i++) {
     RVIBuffer[i] = 
      MathMin(Volume[i],RVI.Period+Bands.Period) * 
      iRVI(NULL, 0, RVI.Period, MODE_MAIN, i);
   }
   
   for(i=0; i<limit; i++) {
     //MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_EMA,PRICE_CLOSE,i);
     MovingBuffer[i] = iMAOnArray(RVIBuffer, 0, Bands.Period, 0, MODE_EMA, i);
   }
   
//----
   i=Bars-Bands.Period+1;
   if(counted_bars>Bands.Period-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+Bands.Period-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         //newres=Close[k]-oldval;
         newres=RVIBuffer[k]-oldval;
         
         sum+=newres*newres;
         k--;
        }
      deviation=Bands.Deviation*MathSqrt(sum/Bands.Period);
      UpperBuffer[i]=oldval+deviation;
      LowerBuffer[i]=oldval-deviation;
      i--;
     }
//----
  }
  
void start() 
{  
  start2();
  
  double fr0, fr1;
  double pw_rvi0, pw_rvi1;
  string obj_name;
  //string ind_name = "i-PowerRVI";
  
  if (Width.Min <= 0) Width.Min = 1;
  
  
  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  
  if (counted > 0) counted--;
  int limit = Bars-counted;
  limit = MathMin(limit, Bars-Width.Max);
  limit = MathMin(limit, MaxBars);
  
  
  for(int i=3; i < limit+3; i++) 
  {
    //UpperFr[i] = 0;
    
    fr0 = iFractals(NULL, 0, MODE_UPPER, i);
    if (fr0 == 0) continue;
    
    pw_rvi0 = RVIBuffer[i];
    pw_rvi0 = MathMax(pw_rvi0, RVIBuffer[i-1]);
    pw_rvi0 = MathMax(pw_rvi0, RVIBuffer[i-2]);
    
    for(int j=i+1; j <= i+Width.Max; j++) 
    {
      pw_rvi1 = RVIBuffer[j];
      //if (pw_rvi1 < 0) break;
    
      fr1 = iFractals(NULL, 0, MODE_UPPER, j);
      if (fr1 == 0) continue;
      if (fr1 >= fr0) break;
      if (j-i <= Width.Min) continue;
    
      if (Height.Min*Point <= fr0-fr1 && fr0-fr1 <= Height.Max*Point) 
      {
        if (pw_rvi1 > pw_rvi0)
        {         
          UpperFr[i] = High[i] + (Shift.Arrow-5)*Point;
          UpperFr2[j] = High[j] + Shift.Dot*Point;
          
          obj_name = prefix+"_u_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], High[i]+Shift.Line*Point, Time[j], High[j]+Shift.Line*Point);
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color1);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }

  for(i=3; i < limit+3; i++) 
  {
    //LowerFr[i] = 0;
    
    fr0 = iFractals(NULL, 0, MODE_LOWER, i);
    if (fr0 == 0) continue;
    
    pw_rvi0 = RVIBuffer[i];
    pw_rvi0 = MathMax(pw_rvi0, RVIBuffer[i-1]);
    pw_rvi0 = MathMax(pw_rvi0, RVIBuffer[i-2]);
            
    for(j=i+1; j <= i+Width.Max; j++) 
    {
      pw_rvi1 = RVIBuffer[j];
      //if (pw_rvi1 > 0) break;
            
      fr1 = iFractals(NULL, 0, MODE_LOWER, j);
      if (fr1 == 0) continue;
      if (fr1 <= fr0) break;
      if (j-i <= Width.Min) continue;

      if (Height.Min*Point <= fr1-fr0 && fr1-fr0 <= Height.Max*Point)
      {
        if (pw_rvi1 < pw_rvi0) 
        {
          LowerFr[i] = Low[i] - Shift.Arrow*Point;
          LowerFr2[j] = Low[j] - Shift.Dot*Point;
          
          obj_name = prefix+"_l_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], Low[i]-Shift.Line*Point, Time[j], Low[j]-Shift.Line*Point);
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color2);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}

